/** 
 * Potentiomenter + LED brightness
 * by BARRAGAN <http://barraganstudio.com>
 * 
 * Reads values from a photoresistor connected to the 
 * analog input pin 0. The value read from the sensor is proportional
 * to the amount of light that hits the sensor surface.
 * The value read is used to dim an LED connected to the PWM uutput pin 37
 */

int sensorValue; 

void setup()
{
  pinMode(37, OUTPUT);
}

void loop() 
{
  sensorValue = analogRead(0);  // read analog input pin 0 (value in the range 0-1023)

  // The LED brightness will be proportional to knob position.

  analogWrite(37, sensorValue);  // write the value to PWM output pin 37 (value in the range 0-1023)

  // if you want the sensorValue of the LED to be inversely proportional to the amount of
  // of light in the environment comment the previous line and use the line below instead:

  //analogWrite(37, 1023-sensorValue);

  delay(100);  // wait 100ms for next reading
}
